<?php

namespace PW\Composer;

use Composer\Composer;
use Composer\IO\IOInterface;
use Composer\Plugin\PluginInterface;

/**
 * The Plugin class
 *
 * @see https://getcomposer.org/doc/articles/plugins.md#plugin-class
 */
class Plugin implements PluginInterface
{
    /**
     * Register installer
     *
     * @param Composer $composer
     * @param IOInterface $io
     */
    public function activate(Composer $composer, IOInterface $io)
    {
        $installer = new SystemInstaller($io, $composer);
        $composer->getInstallationManager()->addInstaller($installer);
    }

   /**
    * Remove any hooks from Composer
    *
    * This will be called when a plugin is deactivated before being uninstalled, but also before it
    * gets upgraded to a new version so the old one can be deactivated and the new one activated.
    *
    * @param Composer $composer
    * @param IOInterface $io
    */
    public function deactivate(Composer $composer, IOInterface $io)
    {
    }

   /**
    * Prepare the plugin to be uninstalled
    *
    * This will be called after deactivate.
    *
    * @param Composer    $composer
    * @param IOInterface $io
    */
    public function uninstall(Composer $composer, IOInterface $io)
    {
    }

}
